Subject: Re: [PATCH v9 6/7] iommu/arm-smmu-v3: Add arm_smmu_invs based arm_smmu_domain_inv_range()

From: Jason Gunthorpe <[email-masked]>
Date: Tue, 27 Jan 2026 14:23:48 -0400

On Tue, Jan 27, 2026 at 10:07:09AM -0800, Nicolin Chen wrote:
> > My understanding has been that this invalidation can run from an IRQ
> > context - we permit the use of the DMA API from an interrupt handler?
> > 
> > I though that for rwsem the read side does not require the _irqsave,
> > even if it is in an irq context, unless the write side runs from an
> > IRQ. 
> 
> Hmm, is "rwsem" a typo? Because it's rwlock_t, which is spinlock :-/

Yeah, sorry

> > Here the write side always runs from a process context.
> > 
> > So the write side will block the IRQ which ensures we don't spin
> > during read in an IRQ.
> 
> And, does write_lock_irqsave() disable global IRQ or local IRQ only?
> 
> Documentation/locking/locktypes.rst mentions "local_irq_disable()"..

It will only disable the local IRQ, since it is a spin type lock an IRQ on
another CPU can spin until it is unlocked.

The main issue is if this CPU takes an IRQ while the write side is
locked and spins, then it will never unlock.

Jason